//+------------------------------------------------------------------+ 
//|                                                SmoothCandleS.mq5 | 
//|                                 Copyright  2005, Varus Henschke | 
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2005, Varus Henschke"
#property link ""
//---   
#property version   "1.00"
#property description "    "
//---     
#property indicator_chart_window
//---    4
#property indicator_buffers 4 
//---     
#property indicator_plots   4
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0                         //        
#define INDICATOR_NAME "SmoothCandleS"  //    
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_LINE
//---     
#property indicator_color1  clrMagenta
//---   -  
#property indicator_style1  STYLE_SOLID
//---    1  2
#property indicator_width1  2
//---   
#property indicator_label1  "Open"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_LINE
//---     
#property indicator_color2  clrDodgerBlue
//---   -  
#property indicator_style2  STYLE_SOLID
//---    2  2
#property indicator_width2  2
//---   
#property indicator_label2  "Low"
//+----------------------------------------------+
//|     3            |
//+----------------------------------------------+
//---   3   
#property indicator_type3   DRAW_LINE
//---     
#property indicator_color3  clrLime
//---   -  
#property indicator_style3  STYLE_SOLID
//---    3  2
#property indicator_width3  2
//---   
#property indicator_label3  "High"
//+----------------------------------------------+
//|     4            |
//+----------------------------------------------+
//---   4   
#property indicator_type4   DRAW_LINE
//---     
#property indicator_color4  clrBlueViolet
//---   -  
#property indicator_style4  STYLE_SOLID
//---    4  2
#property indicator_width4  2
//---   
#property indicator_label4  "Close"
//+----------------------------------------------+
//|                     |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMAO,XMAL,XMAH,XMAC;
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method XMA_Method=MODE_SMA;  //  
input int XLength=5;                      //                      
input int XPhase=100;                     //  
//--- XPhase:  JJMA    -100 ... +100,     ;
//--- XPhase:  VIDIA   CMO,  AMA    
input int Shift=0;                        //      
//+----------------------------------------------+
//---   ,   
//---      
double HBuffer[];
double LBuffer[];
double OBuffer[];
double CBuffer[];
//---      
int min_rates_total;
//+------------------------------------------------------------------+    
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+  
int OnInit()
  {
//---    
   min_rates_total=GetStartBars(XMA_Method,XLength,XPhase)+1;
//---   
   IndInit(0,OBuffer,0.0,min_rates_total,Shift);
   IndInit(1,LBuffer,0.0,min_rates_total,Shift);
   IndInit(2,HBuffer,0.0,min_rates_total,Shift);
   IndInit(3,CBuffer,0.0,min_rates_total,Shift);
//---           
   string shortname;
   StringConcatenate(shortname,INDICATOR_NAME,"(",XLength,")");
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(RESET);
//---    
   int first,bar;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-1; //      
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---    XMASeries.  
      OBuffer[bar]=XMAO.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength,open [bar],bar,false);
      CBuffer[bar]=XMAC.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength,close[bar],bar,false);
      HBuffer[bar]=XMAH.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength,high [bar],bar,false);
      LBuffer[bar]=XMAL.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,XLength,low  [bar],bar,false);
     }
//---         
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+    
void IndInit(int Number,double &Buffer[],double Empty_Value,int Draw_Begin,int nShift)
  {
//---      
   SetIndexBuffer(Number,Buffer,INDICATOR_DATA);
//---      
   PlotIndexSetInteger(Number,PLOT_DRAW_BEGIN,Draw_Begin);
//---   ,      
   PlotIndexSetDouble(Number,PLOT_EMPTY_VALUE,Empty_Value);
//---    2    Shift
   PlotIndexSetInteger(Number,PLOT_SHIFT,nShift);
//---
  }
//+------------------------------------------------------------------+
